//
// Copyright 2016, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure may be covered by the
// same copyright.  Some of them may be part of the GNU source distribution
// and you must obey the GPL copyright for any such files.

char const *brashVersionLog[]=
{
    "\r\n",
    "Brash Version Log and Copyright Information.\r\n\r\n",
    "Versions:\r\n",
    "\r\n",
    "01.01.40 - Bug Fixed:   Bug in .linreg when last line did not end in newline\r\n",
    "01.01.39 - Bug Fixed:   Segment violation when executiong cmd /c <nothing>\r\n",
    "01.01.38 - Enhancement: Adding -n and -z [ operators ] and modified builtins logging.\r\n",
    "01.01.37 - Enhancement: Added additional [ operators ] and modified builtins to explain\r\n",
    "01.01.36 - Bug fixed: calling a function was corrupting $@ of the current scope\r\n",
    "01.01.35 - Bug fixed: getopt infinite loop bug if user specified multiple options in one -group\r\n",
    "01.01.34a- Port:      Port to Visual Studio 2015, no functionality changes\r\n",
    "01.01.33 - Bug fixed: $_ not working if last command was a script function\r\n",
    "           Bug fixed: function definitions now accept ; as a statement separator before { or (\r\n",
    "01.01.32 - Bug fixed: yet another cursor position bug when you scroll off the bottom\r\n",
    "                      of the windows console 'screen buffer' while typing a command.\r\n",
    "01.01.31 - Bug fix:   positioning bug when cursor at bottom of windows\r\n",
    "                      screen buffer.\r\n",
    "01.01.30 - Maint:     code restructuring for pipe issues.\r\n",
    "01.01.29 - Bug fix:   major bug:  while loops would terminate early if the\r\n",
    "                      body of the loop used $() or ``.  Hopefully fixed...\r\n",
    "01.01.28 - Bug fix:   now support '\\\\' as '\\' in PS1.\r\n",
    "01.01.27 - Improved:  upstream pipe members were hanging when the downstream\r\n",
    "                      members died too soon.  Timeout is now set to 50ms before \r\n",
    "                      upstream pipe members try to connect to downstream members\r\n",
    "01.01.26 - Improved:  error messages for break & continue use dout of place\r\n",
    "01.01.25 - Bug fix:   eval exit no longer crashes -- bug does nothing\r\n",
    "           Bug fix:   echo yes | exit 1 -- no longer crashes or exits -- per bash behaivor\r\n",
    "           Bug fix:   child shell script error code is no longer lost\r\n",
    "01.01.24 - Improved:  .wc now supports reading from stdin\r\n",
    "01.01.23 - Improved:  help listing from the set command\r\n",
    "01.01.22 - Added:  .stopwatch\r\n",
    "01.01.21 - Added:  -f and -h options to the set command.  -f turns off globbing.  +f turns it on\r\n",
    "01.01.20 - Added:  .linreg a linear regression calculator.\r\n",
    "01.01.19 - Bug fix:  error codes were being lost when command line redirection was used.\r\n",
    "           Added:  .solve command.\r\n",
    "01.01.18 - Bug fix:  When executing strings as commands, as when you do `cmd`\r\n",
    "           there were occaisional exceptions thrown due to closed stdin files.\r\n",
    "01.01.17 - Bug Fix:  redirecting stdout for any line in a while statement body was\r\n",
    "           causing the loop to terminate if the while loop was using a 'read'\r\n",
    "           command to process data.\r\n",
    "01.01.16 - Bug fix:  Interpretation of the following command line redirection now\r\n",
    "           works as intended:  1>&3.  But note that file handles > 3 do not get\r\n",
    "           passed to child processes -- and likely won't\r\n",
    "         - Improved:  added -e and -i options to .regex\r\n",
    "         - Reworked:  IFS variable interpretation.\r\n",
    "01.01.15 - Bug fix:  the -script option was not passing arguments to the script\r\n",
    "         - Bug fix:  '$@' was not being evaluated as nothing if there were no args\r\n",
    "                     instead it was evaluated as '' -- which is something.\r\n",
    "         - Improved .rename error messages\r\n",
    "01.01.14 - Bug fix:  while statements were treating continues like they were breaks\r\n",
    "         - Added .rename\r\n",
    "01.01.13 - Bug fix:  echo '-- stuff' was being misinterpreted as '--'\r\n",
    "         - Added .wc command\r\n",
    "01.01.12 - Better ^C detection in .ls\r\n",
    "01.01.11 - Added copyright information to the .ver builtin command\r\n",
    "01.01.10 - Improvement to .diff command outputs.\r\n",
    "         - Improvements to the builtins command outputs. \r\n",
    "01.01.09 - Minor spelling corrections.\r\n",
    "01.01.08 - Removed extraneous quotes around external command parameters.\r\n",
    "01.01.07 - Adding .expand.  Use the -u option to un-expand.\r\n",
    "         - Fixed a bug in the handling of i/o redirection errors.\r\n",
    "01.01.06 - Added .head and .cut commands\r\n",
    "01.01.05 - New features:  new program option, '-rc file', superseeds .brashrc\r\n",
    "           Bugs fixed:  piping from one external command to another was unstable.\r\n",
    "01.01.04 - Bugs fixed:\r\n",
    "           - fixed end of line sequences in messages\r\n",
    "01.01.03 - Bugs fixed:\r\n",
    "           -  shift now accepts expressions not just constants.\r\n",
    "           -  fixed crash when $OPTIND on startup befor $@ was properly assigned.\r\n",
    "01.01.02 - Bugs fixed:\r\n"
    "           -  Console flakiness bug seems to have gone away on its own\r\n",
    "           -  ~ character at the begining of word now expands correctly\r\n",
    "              When the tab-completion feature is used\r\n",
    "01.01.01 - Barely functional first release -- still some console flakiness\r\n",
    "           but scripting, piping, and background jobs all seem to work ok.\r\n",
    "\r\n",
    "Copyright Holders:\r\n",
    "\r\n",
    "   Copyright Lowell Boggs, Jr.  2016 -- for brash.  See details below.\r\n",
    "\r\n",
    "   Copyight GNU General Public License, 1993 -- for regex.c and .h\r\n",
    "\r\n",
    "   Copyright GNU Library Public License, 1991 -- for fnmatch.c\r\n",
    "\r\n",
    "   Copyright David L. Nugent, 1996 -- for parse_date.c\r\n",
    "       *  http://www.gnu-darwin.org/sources/src/usr.sbin/pw/psdate.c\r\n",
    "\r\n",
    "   Copyright WikiBooks.org:  LCS Algorithm used in .diff\r\n",
    "       *  https://en.wikibooks.org/w/index.php?title=Algorithm_Implementation/Strings/Longest_common_subsequence\r\n",
    "\r\n",
    "   Copyright (c) 1980, 1987, 1991, 1993 -- for wc.c (word count algorithm)\r\n",
    "       *  The Regents of the University of California.  All rights reserved.\r\n",
    "\r\n",
    "Brash Copyright:\r\n",

    "    //\r\n",
    "    // Copyright 2002-2016, Lowell Boggs Jr.\r\n",
    "    //\r\n",
    "    // This file or directory, containing source code for a computer program,\r\n",
    "    // is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville\r\n",
    "    // TX (USA), 75067.  You may use, copy, modify, and distribute this\r\n",
    "    // source file without charge or obligation so long as you agree to\r\n",
    "    // the following:\r\n",
    "    //\r\n",
    "    //  1.  You must indemnify Lowell Boggs against any and all financial\r\n",
    "    //      obligations caused by its use, misuse, function, or malfunction.\r\n",
    "    //      Further, you acknowledge that there is no warranty of any kind,\r\n",
    "    //      whatsoever.\r\n",
    "    //\r\n",
    "    //  2.  You agree not to attempt to patent any portion of this original\r\n",
    "    //      work -- though you may attempt to patent your own extensions to\r\n",
    "    //      it if you so choose.\r\n",
    "    //\r\n",
    "    //  3.  You keep this copyright notice with the file and all copies\r\n",
    "    //      of the file and do not change it anyway except language translation.\r\n",
    "    //\r\n",
    "    // You are responsible for enforcing your own compliance with these\r\n",
    "    // conditions and may not use this source file if you cannot agree to the\r\n",
    "    // above terms and conditions.\r\n",
    "    //\r\n",
    "    // Warning:  not all files in this directory structure may be covered by the\r\n",
    "    // same copyright.  Some of them may be part of the GNU source distribution\r\n",
    "    // and you must obey the GPL copyright for any such files.\r\n",
    "\r\n",
    (char const *)(0) // must be last
};
